<script setup>
import QRCodeVue from 'qrcode.vue';
import { store } from '@/store';
import { onMounted } from 'vue';
import { defineEmits } from "vue";
import { watch } from 'vue';
import { truncate } from 'lodash';

const emitClick = defineEmits(["closeModal"]);
const { getAssetImage } = commonHelper;
const props = defineProps({
    isShowQrCodePopup: {
        type: Boolean,
        default: false,
    },
    PayoutInfo: {
        type: Object,
        default: {},
    },
    onBeforeClose: {
        type: Function,
        required: true,
    },
});

const onlineId = localStorage.getItem('betlisttokenid');
const qrUrl = computed(() => {
    return `${window.location.origin}/sport-qr?pid=${props.PayoutInfo.PayoutId}&token=${encodeURIComponent(props.PayoutInfo.Token)}&oid=${onlineId}`;
});
const auth = computed(() => store.state.auth);
if (!auth.value) localStorage.removeItem("betlisttokenid");


let targetTime = 3 * 60;
const startTimer = () => {
    targetTime = 3 * 60;
    const now = new Date().getTime();

    // Calculate the remaining time
    let remainingTime = targetTime - Math.floor((new Date().getTime() - now) / 1000);
    const timerInterval = setInterval(() => {
        if (props.isShowQrCodePopup === false) {
            clearInterval(timerInterval);
        }
        // Calculate minutes and seconds
        const minutes = Math.floor(remainingTime / 60);
        const seconds = remainingTime % 60;

        // Format the time string
        const timeString = `${minutes.toString().padStart(1, "0")}:${seconds.toString().padStart(2, "0")}`;

        // Display the time
        document.getElementById("timer").textContent = timeString;

        // Check if countdown is finished
        if (remainingTime === 0) {
            clearInterval(timerInterval);
            emitClick("closeModal");
        }

        // Decrease remaining time by 1 second
        remainingTime--;
    }, 1000);
}
watch(() => props.isShowQrCodePopup, () => {
    if (props.isShowQrCodePopup === true) {
        if (document.getElementById("timer")) {
            document.getElementById("timer").textContent = '3:00';
        }
        // 3 minutes in seconds
        targetTime = 3 * 60;
        startTimer();
    } 
});

</script>

<template>
    <div class="sport-qr">
        <el-dialog v-model="props.isShowQrCodePopup" class="custom-dialog" width="715px" :show-close="false"  :close-on-click-modal="false">
            <div class="text-xl flex justify-center items-center py-4 px-4 fc-text4 font-bold bet-success rounded-t-2xl">
                {{ $t('Your bet was placed successfully') }}
            </div>
            <div class="text-xl flex justify-center items-center py-4 px-4 fc-text4 payout">
                {{ $t('Please payout in') }} <span id="timer" class="font-bold text-2xl fc-failure px-2"> 3:00 </span> <span class="lowercase">{{ $t('minutes')  }}</span>.
            </div>
            <div class="flex justify-center items-center">
                <div class="flex-1 border-gray-500 p-6">
                    <div class="scan-text-info">
                        <span style="word-break: break-word;">{{ $t('Please use your mobile phone to scan the QR Code to retrieve the bet slip and complete the payment within 3 minutes, or the bet slip will be canceled.') }}</span>
                    </div>
                    <div class="flex justify-center mt-4">
                        <img :src="getAssetImage('assets/common/scan-qr.png')" alt="scanqr-gif" class="w-[190px] h-[190px]">
                    </div>
                </div>
                <div class="flex-1 space-y-4 p-6">
                    <div class="flex justify-center items-center fc-dialog text-xl font-bold">
                        <span>
                            {{ $t('Scan QR Code')  }}
                        </span> 
                        <SvgIcon svg-name="arrow-down-long" class-name="h-6 w-6" style="fill: var(--dialog-color);" />
                    </div>
                    <div class="flex justify-center">
                        <QRCodeVue
                            id="qrCode"
                            :value="qrUrl"
                            size="200"
                            class="p-2 bg-white rounded"
                        ></QRCodeVue>
                    </div>
                    <div class="flex justify-center">
                        <button id="scan-btn" class="bg-primary rounded-[4px] py-2 px-3 font-bold fc-textBtn" @click="onBeforeClose">
                            {{ $t('I Already Scanned') }}
                        </button>
                    </div>
                </div>
            </div>
        </el-dialog>
    </div>
</template>

<style lang="scss">
    .custom-dialog {
        .el-dialog__body {
            padding: 0;
        }
    }
    .sport-qr {
        .scan-text-info {
            color: var(--text5, #FFF);
            font-family: Inter;
            font-size: 14px;
            font-style: normal;
            font-weight: 400;
            line-height: normal;
        }

        & .el-dialog {
            background: linear-gradient(0deg, rgba(0, 0, 0, 0.25) 0%, rgba(0, 0, 0, 0.25) 100%), var(--Background5, #202821);
            border-radius: 16px;
        }
        .el-dialog__header {
            display: none;
        }

        .bet-success {
            background: linear-gradient(0deg, rgba(0, 0, 0, 0.00) 0%, rgba(0, 0, 0, 0.00) 100%), var(--Background5, #202821);
            border-bottom: 2px solid var(--border);
        }
        .payout {
            border-bottom: 1px solid var(--border);
        }
    }
</style>